#!/bin/sh
# Lex, 19-Apr-06
# The remote side of the Audigy 2 LED control script.
# To execute a command, a connection is made to a port on the remote host,
# where nc is running.  An action is then selected from a 'case' construct.

# Do 'amixer -c <card> contents' to see card contents.
# Command : ${amixer} -c ${card} "${setting}"

# Amixer-specific stuff
# 'amixer' command name
amixer="amixer"
# Card number
card="1"

# Other settings
# Port to listen on
port="29182"

# Amixer function
# An example of a command:
# amixer -c 1 cset name='Dolby Digital LED Switch' off
# This was a real bast to get working, due to the quotes.
function amixerx()
{
	name="$1"
	setting="$2"
	$amixer -c ${card} cset name="$name" ${setting}
}

while [ 1 ]; do
  date="`date`"
  comm="`nc -l -p ${port}`"
  echo -e "${date}:\tReceived command: $comm"
  # Set return string
  return="Command '${comm}' received at ${date}"
  case "$comm" in
  dolby_off)
  	  name="Dolby Digital LED Switch"
	  setting="off"
	  amixerx "$name" "$setting"
          ;;
  dolby_on)
          name="Dolby Digital LED Switch"
	  setting="on"
	  amixerx "$name" "$setting"
          ;;
  power_on)
          name="Power LED Switch"
          setting="on"
	  amixerx "$name" "$setting"
          ;;
  power_off)
          name="Power LED Switch"
          setting="off"
	  amixerx "$name" "$setting"
          ;;
  cmss_on)
          name="CMSS LED Switch"
          setting="on"
	  amixerx "$name" "$setting"
          ;;
  cmss_off)
          name="CMSS LED Switch"
          setting="off"
	  amixerx "$name" "$setting"
          ;;
  mute_on)
          name="Master Playback Switch"
          setting="off"
	  amixerx "$name" "$setting"
          ;;
  mute_off)
          name="Master Playback Switch"
          setting="on"
	  amixerx "$name" "$setting"
	  ;;
  vol_10) name="Master Playback Volume"
          setting="10%"
	  amixerx "$name" "$setting"
  	  ;;
  vol_20) name="Master Playback Volume"
          setting="20%"
          amixerx "$name" "$setting"
          ;;
  vol_30) name="Master Playback Volume"
	  setting="30%"
	  amixerx "$name" "$setting"
	  ;;
  vol_40) name="Master Playback Volume"
          setting="40%"
	  amixerx "$name" "$setting"
	  ;;
  vol_50) name="Master Playback Volume"
          setting="50%"
	  amixerx "$name" "$setting"
	  ;;
  vol_60) name="Master Playback Volume"
  	  setting="60%"
	  amixerx "$name" "$setting"
	  ;;
  vol_70) name="Master Playback Volume"
          setting="70%"
          amixerx "$name" "$setting"
          ;;
  vol_80) name="Master Playback Volume"
          setting="80%"
          amixerx "$name" "$setting"
          ;;
  vol_90) name="Master Playback Volume"
          setting="90%"
          amixerx "$name" "$setting"
          ;;
 vol_100) name="Master Playback Volume"
          setting="100%"
          amixerx "$name" "$setting"
          ;;
  reboot) wall "$0: Someone clicked 'reboot' on the 'LED Control Page'."
  	  ;;
  shutdown)
 	  wall "$0: Someone clicked 'shutdown' on the 'LED Control Page'."
  	  ;;
  exit)   break
          ;;
  bell)
          # Play a loud, annoying sound (on the internal sound device, so
	  # people can't turn the volume up to maximum and blast the smeg
	  # out the speakers).
	  play bell.wav
	  ;;
  status)
          # If the rest of this script is klugy, this REALLY is.  The
	  # script has to return output to the calling script on Cranefly.
	  # Hence, Cranefly opens a port and waits for a reply.  There's
	  # a potential DOS here, but who cares.. (16-Apr-06)
	  return="<p><b>Press Esc here to stop refresh</b><pre>`amixer -c1 contents`</pre>"
	  ;;
  fortune)
  	  return="<pre>`fortune`</pre>"
	  ;;
  uptime)
	  return="<pre>`uptime`</pre>"
	  ;;
  camera)
  # This relies on a video device being available.  Try the SlimPix (see
  # IrcLog).  How can I embed an image directly into HTML?  Is that possible?
  # Yes, using 'multipart form data'.  See IrcLog.
          return="<pre>`streamer -q -c /dev/video0 -f jpeg -o /dev/stdout | hexdump -v`</pre>"
	  ;;
  *)
	  echo "Unrecognised command: $comm"
	  ;;
  esac
          # Reply to the web server, outputting any results
          echo -en "$return" | nc 192.168.135.8 ${port}
  sleep 1
done
