#!/bin/sh
# Setting the Audigy 2 NX LEDs via ssh
# 14-Apr-06

stdin="`cat`"

# Refresh delay
refresh="5"
# Refresh URL
# (used to be '$HTTP_REFERER' but this caused problems when the script
# refers to itself.. sigh..)
url="/ledcontrol.html"

# Write headers
echo -en "Content-type: text/html\r\n\r\n<html>"
echo "<meta http-equiv='Refresh' CONTENT=${refresh};URL=${url}><head></head><body>"

host="remote.hostname"
# The webserver host also listens on this port for a reply
port="29182"
sleep="2"

# Remove 'submit=' from the input
setting="`echo $stdin | cut -d '=' -f 2`"
echo "<p>Set: $setting<br>"

# The remote runs a script which listens for commands.  This is klugy but I
# can't think of any other way to do it.  ssh would require creating ssh
# keys for Apache on this side and an account on the other side, and there
# would be no way I could limit the commands executed, making it a security
# risk.
echo "$setting" | nc ${host} ${port}

# Wait for a reply (don't wait long!)
return="`nc -w${sleep} -l -p ${port}`"
RC="$?"
if [ "$RC" -ne 0 ]; then
  return="<pre>The command didn't execute - remote script not running? (return code ${RC})</pre>"
fi

# Echo any output and close the document
echo -ne "${return}</body></html>"

# Delay to stop DOS attacks
sleep ${sleep}
